/*
 * @Author: Jimmy jimmy.jiang@vinno.com
 * @Date: 2022-06-23 20:39:01
 * @LastEditors: Jimmy jimmy.jiang@vinno.com
 * @LastEditTime: 2022-07-01 15:50:50
 * @FilePath: \fis_lib_pdf\lib\main.dart
 * @Description: 
 * 
 * Copyright (c) 2022 by Jimmy jimmy.jiang@vinno.com, All Rights Reserved. 
 */
import 'package:fis_lib_pdf/ultils/pdf_access_type.dart';
import 'package:fis_lib_pdf/ultils/pdf_type_enum.dart';
import 'package:flutter/material.dart';
import 'pdf_render_container.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'PDF Demo',
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
      ),
      home: const MyHomePage(title: 'PDF Demo'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({Key? key, required this.title}) : super(key: key);

  // This widget is the home page of your application. It is stateful, meaning
  // that it has a State object (defined below) that contains fields that affect
  // how it looks.

  // This class is the configuration for the state. It holds the values (in this
  // case the title) provided by the parent (in this case the App widget) and
  // used by the build method of the State. Fields in a Widget subclass are
  // always marked "final".

  final String title;

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  @override
  Widget build(BuildContext context) {
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.
    return const Scaffold(
      body: Center(
          child: FPDFRenderContainer(
        pdfTypeEnum: PDFTypeEnum.report,
        demoMode: true,
        pdfAccessTypeEnum: PDFAccessTypeEnum.preview,
        pdfExporter: null,
        cacheGet: null,
        cacheSave: null,
        fromEditor: false,
      )),
    );
  }
}
