/*
 * @Author: Jimmy jimmy.jiang@vinno.com
 * @Date: 2022-06-23 20:39:01
 * @LastEditors: Jimmy jimmy.jiang@vinno.com
 * @LastEditTime: 2022-07-01 17:39:07
 * @FilePath: \fis_lib_pdf\lib\pdf_objects\pdf_container.dart
 * @Description: 
 * 
 * Copyright (c) 2022 by Jimmy jimmy.jiang@vinno.com, All Rights Reserved. 
 */
// ignore: file_names
import 'package:fis_lib_pdf/pdf_objects/pdf_element.dart';
import 'package:fis_lib_report/report_info/block_element_info_interface.dart';
import 'package:pdf/widgets.dart' as pw;

abstract class PDFContainer extends PdfElement {
  PDFContainer(this.elementList);
  final List<IBlockElementInfo> elementList;

  pw.Widget _createElements() {
    var childrens = <pw.Widget>[];
    for (var element in elementList) {
      var ouputWidget = generateElementByBlockInfo(element);

      childrens.add(ouputWidget);
    }
    return pw.Column(
        mainAxisAlignment: pw.MainAxisAlignment.start, children: childrens);
  }

  @override
  pw.Widget generatePDFElement() {
    return pw.Container(child: _createElements());
  }

  List<pw.Widget> generatedPDFElements() {
    var childrens = <pw.Widget>[];
    for (var element in elementList) {
      var ouputWidget = generateElementByBlockInfo(element);

      childrens.add(ouputWidget);
    }

    return childrens;
  }
}
