/*
 * @Author: Jimmy jimmy.jiang@vinno.com
 * @Date: 2022-06-23 20:39:01
 * @LastEditors: Jimmy jimmy.jiang@vinno.com
 * @LastEditTime: 2022-07-01 14:00:20
 * @FilePath: \fis_lib_pdf\lib\pdf_objects\report\pdf_paragraph.dart
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
import 'package:fis_lib_pdf/pdf_objects/pdf_element.dart';
import 'package:fis_lib_pdf/pdf_objects/report/report_helper/report_style_helper.dart';
import 'package:pdf/widgets.dart' as pw;
import './report_helper/report_dic.dart';

class PdfParagraph extends PdfElement {
  PdfParagraph(this.paragraphInfo);
  ParagraphInfo paragraphInfo;

  @override
  pw.Widget generatePDFElement({bool isParentRTCell = false}) {
    var childs = <pw.Widget>[];

    for (var olo in paragraphInfo.elementInfos!) {
      if (paragraphInfo.elementInfos!.length == 1) {
        if (_hasInputText()) {
          return generateElementByElementType(olo,
              parentElementHasNoContainer: true,
              parentIsTable: _parentIsGrid(),
              parentIsRTCell: isParentRTCell);
        }
        if (_parentIsGrid()) {
          return generateElementByElementType(
            olo,
            parentElementHasNoContainer: _hasInputText(),
            parentIsTable: true,
            parentIsRTCell: isParentRTCell,
          );
        }
      }

      childs.add(
          generateElementByElementType(olo, parentIsRTCell: isParentRTCell));
    }

    var elementHorizontalAlignment =
        paragraphInfo.element?.horizontalAlignment!;
    var elementVerticalAlignment = paragraphInfo.element?.verticalAlignment!;

    return pw.Wrap(
      children: childs,
      crossAxisAlignment:
          ReportStyleHelper.getWrapCrossAlignment(elementVerticalAlignment!),
      alignment:
          ReportStyleHelper.getWrapAlignment(elementHorizontalAlignment!),
    );
  }

  bool _hasInputText() {
    for (var e in paragraphInfo.elementInfos!) {
      if (e is InputTextInfo && paragraphInfo.parent == null) {
        return true;
      }
    }
    return false;
  }

  bool _parentIsGrid() {
    if (paragraphInfo.element == null) {
      return false;
    }
    if (paragraphInfo.element!.parent == null) {
      return true;
    }

    return false;
  }
}
