// ignore_for_file: non_constant_identifier_names
import 'dart:typed_data';

import 'package:fis_lib_pdf/report_render.dart';
import 'package:fis_lib_pdf/ultils/pdf_type_enum.dart';
import 'package:pdf/pdf.dart';

/// PDF渲染函数工厂
class PDFRenderFactory {
  //根据具体的Pdf枚举类型返回不同的pdf文档函数
  static Future<Uint8List> Function(
          PdfPageFormat pageFormat, List<String>? jpegReportsUrls)
      GetPDFRenderByPDFTypeEnum(PDFTypeEnum pdfTypeEnum) {
    if (pdfTypeEnum == PDFTypeEnum.report) {
      return generateReport;
    }
    if (pdfTypeEnum == PDFTypeEnum.pdfBytes) {
      return generateByGivenPDFBytes;
    }
    if (pdfTypeEnum == PDFTypeEnum.pdfJpeg) {
      return generateByGivenPDFJpges;
    }
    return generateReport;
  }
}
